package typo.parse;

import java.io.*;
import java.net.*;
import java.util.*;

import java_cup.runtime.Symbol;

import typo.term.*;

/** Parses a single file.  I know, it's a weird name, but class
 * names including "parse" seem to have problems. */
public class ParseOne {

  /** The value of the term that was parsed. */
  public Term value;

  /** Parses a file.
   * @param r  a Reader, reading the file to be parsed */
  public ParseOne(Reader r) throws Exception {
    parser p = new parser(new Yylex(r));
    Symbol s = p.parse();
    this.value = (Term) s.value;
  }

  /** Reads a file from a given URL, and parses it.
   * FIXME: this should read from local files, as well as
   *   from over the Web.
   * @param url  the URL of the file to parse */
  public ParseOne(URL url) throws Exception {
    // FIXME: perhaps this ought to pay attention to the
    // Content-type header?
    Reader r = new BufferedReader(
                 new InputStreamReader(url.openStream()));
System.out.println("created Reader");
    parser p = new parser(new Yylex(r));
    p.url = url;
    Symbol s = p.parse();
    this.value = (Term) s.value;
  }


}

