; Given a list of lists
;   ((a1 a2 ...) (b1 b2 ...) ... (z1 z2 ...))
; returns a list of all combinations
;   ((a1 b1 ... z1) (a1 b1 ... z2) ...
; made by taking one element from each sub-list.  This will typically
; be a long list, which is unfortunate, but I'm trying to keep the
; program logic simple.
; 20020422, jtb: started

(require 'common-list-functions)

(define (list_combinations a)
  (if (null? a)
      '(())
      (let ((b1 (car a))
	    (c1 (list_combinations (cdr a))))
	(reduce append (map (lambda (b)
	       (map (lambda (c)
		      (cons b c))
		    c1))
	     b1)))))
	      	 
; tests
; (list_combinations '())
; (list_combinations '((a b c)))
; (list_combinations '((i ii) (a b) (1 2)))



